﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Slicer
{
    public partial class Form1 : Form
    {
        Block[] bloks;
        int AA = -1, BB = -1;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog opf = new OpenFileDialog();

            if (opf.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return;
            List<string> Lines = new List<string>();
            string line = "";
            StreamReader sr = new StreamReader(opf.FileName);
            while ((line = sr.ReadLine()) != null)
            {
                Lines.Add(line);
            }
            var splita = Lines[0].Split(' ').Where(item => item != "").ToArray();
            AA = int.Parse(splita[0]);
            BB = int.Parse(splita[1]);
            bloks = Lines.Skip(1).Where(item => item != "").SelectMany(select =>
                 {
                     string[] split = select.Split(' ').Where(item => item != "").ToArray();
                     int patro = int.Parse(split[0]);
                     int X = int.Parse(split[1]) - 1;
                     int Y = int.Parse(split[2]) - 1;
                     Color barva = Color.AliceBlue;
                     switch (split[3].ToUpper())
                     {
                         case "A":
                             barva = Color.FromArgb(0, 255, 255);
                             break;
                         case "R":
                             barva = Color.FromArgb(255, 0, 0);
                             break;
                         case "G":
                             barva = Color.FromArgb(0, 255, 0);
                             break;
                         case "B":
                             barva = Color.FromArgb(0, 0, 255);
                             break;
                         case "Y":
                             barva = Color.FromArgb(255, 255, 0);
                             break;

                         default:
                             break;
                     }
                     split = split[4].ToLower().Split('x');
                     int A = int.Parse(split[0]);
                     int B = int.Parse(split[1]);
                     var blocky = new List<Block>();
                     for (int ia = 0; ia < A; ia++)
                     {
                         for (int ib = 0; ib < B; ib++)
                         {
                             blocky.Add(new Block(X + ia, Y + ib, patro, barva));
                         }
                     }


                     return blocky;

                 }).ToArray();
            DrawLevel(1);
        }
        void DrawLevel(int level)
        {
            const int AAA = 20;
            pictureBox1.Image = new Bitmap(BB*AAA+2, AA*AAA+2);
            Graphics g = Graphics.FromImage(pictureBox1.Image);
            
            bool found = false;
            foreach (var item in bloks)
            {
                if (item.Z == level)
                {
                    g.FillRectangle(new SolidBrush(item.Barva), item.X * AAA, item.Y * AAA, AAA, AAA);
                    found = true;
                }
            }
            if (!found)
            {
                MessageBox.Show("Patro nenalezeno");
                return;
            }
            for (int x = 0; x <= AA; x++)
            {
                g.DrawLine(Pens.Black, x * AAA, 0, x * AAA, AAA * AA);
            }
            for (int y = 0; y <= BB; y++)
            {
                g.DrawLine(Pens.Black, 0, y * AAA, AAA * BB, y * AAA);
            }

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            DrawLevel((int)numericUpDown1.Value);
        }
    }
    class Block
    {
        public int X, Y, Z;
        public Color Barva;
        public Block(int X, int Y, int Z, Color c)
        {
            this.X = X;
            this.Y = Y;
            this.Z = Z;
            Barva = c;
        }
    }
}
