﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Stavitel
{
    class Program
    {
        static public string path = @"";
        static public Random rnd = new Random();
        static void Main(string[] args)
        {
            path = string.Join(" ", args);
            var files = Directory.GetFiles(path, "*.in");
            for (int i = 0; i < files.Length; i++)
            {
                StreamReader sr = new StreamReader(files[i]);
                int X, Y;
                string Type;
                string[] line = sr.ReadLine().Split(new char[] { ' ' }).Where(item => item != "").ToArray();
                X = int.Parse(line[0]);
                Y = int.Parse(line[1]);
                Type = line[2].ToLower();
                List<Kostka> kostky = new List<Kostka>();
                string Line1 = "";
                while ((Line1 = sr.ReadLine()) != null)
                {
                    var tmp = Line1.ToLower().Split(' ').Where(item => item != "").ToArray();
                    var rozmer = tmp[1].Split('x');

                    for (int ii = int.Parse(tmp[2]); ii > 0; ii--)

                        kostky.Add(new Kostka(tmp[0][0], int.Parse(rozmer[0]), int.Parse(rozmer[1])));

                }
                sr.Close();
                var kostkyordered = kostky.OrderByDescending(item => item.A * item.B);
                switch (Type)
                {
                    case "p":
                        VezP(kostkyordered, X, Y, files[i]);
                        break;
                    case "pb":
                        VezPB(kostkyordered, X, Y, files[i]);
                        break;
                    case "d":
                        VezPB(kostkyordered, X, Y, files[i]);
                        break;
                    case "db":
                        VezPB(kostkyordered, X, Y, files[i]);
                        break;
                    default:
                        break;
                }


            }
        }

        static void VezP(IEnumerable<Kostka> kostky, int X, int Y, string file)
        {

            List<Patro> Patra = new List<Patro>();
            Patro patrotmp = new Patro(X, Y);
            int XX, YY;
            while (true)
            {
                bool Spacefound = GetFreePositionP(patrotmp, out XX, out YY);
                if (!Spacefound)
                {
                    Patra.Add(patrotmp);
                    patrotmp = new Patro(X, Y);
                    continue;
                }
                bool rotated = false;
                Kostka found;
                try
                {
                    found = kostky.First(item => item.IsFitting(patrotmp, XX, YY, out rotated));
                }
                catch { found = null; }
                if (found != null)
                {
                    found.Place(patrotmp, XX, YY, rotated);
                    found.rotated = rotated;
                    kostky = kostky.Where(item => item != found);
                }
                else { break; }
            }
            Patro.WriteToFile(file.Replace(".in", ".39"), Patra.ToArray(), "P", X, Y);

        }
        static void VezD(IEnumerable<Kostka> kostky, int X, int Y, string file)
        {

            List<Patro> Patra = new List<Patro>();
            Patro patrotmp = new Patro(X, Y);
            int XX, YY;
            while (true)
            {
                bool Spacefound = GetFreePositionP(patrotmp, out XX, out YY);
                if (!Spacefound)
                {
                    Patra.Add(patrotmp);
                    patrotmp = new Patro(X, Y);
                    continue;
                }
                bool rotated = false;
                Kostka found;
                try
                {
                    found = kostky.First(item => item.IsFitting(patrotmp, XX, YY, out rotated));
                }
                catch { found = null; }
                if (found != null)
                {
                    found.Place(patrotmp, XX, YY, rotated);
                    found.rotated = rotated;
                    kostky = kostky.Where(item => item != found);
                }
                else { break; }
            }
            Patro.WriteToFile(file.Replace(".in", ".39"), Patra.ToArray(), "D", X, Y);

        }
        static void VezPB(IEnumerable<Kostka> kostky, int X, int Y, string file)
        {

            List<Patro> Patra = new List<Patro>();
            Patro patrotmp = new Patro(X, Y);
            int XX, YY;
            while (true)
            {
                bool Spacefound = GetFreePositionP(patrotmp, out XX, out YY);
                if (!Spacefound)
                {
                    Patra.Add(patrotmp);
                    patrotmp = new Patro(X, Y);
                    continue;
                }
                bool rotated = false;
                Kostka found;
                try
                {
                    found = kostky.First(item =>
                    {
                        bool firstcond =
                        item.IsFitting(patrotmp, XX, YY, out rotated);
                        if (!firstcond)
                            return false;

                        Patro n_1 = (Patra.Count > 0) ? Patra[Patra.Count - 1] : null;

                        return !patrotmp.EdgeColorMatch(item, XX, YY, rotated, n_1);


                    });
                }
                catch { found = null; }
                if (found != null)
                {
                    found.Place(patrotmp, XX, YY, rotated);
                    found.rotated = rotated;
                    kostky = kostky.Where(item => item != found);
                }
                else { break; }
            }
            Patro.WriteToFile(file.Replace(".in", ".39"), Patra.ToArray(), "PB", X, Y);

        }

        static void VezDB(IEnumerable<Kostka> kostky, int X, int Y, string file)
        {

            List<Patro> Patra = new List<Patro>();
            Patro patrotmp = new Patro(X, Y);
            int XX, YY;
            while (true)
            {
                bool Spacefound = GetFreePositionP(patrotmp, out XX, out YY);
                if (!Spacefound)
                {
                    Patra.Add(patrotmp);
                    patrotmp = new Patro(X, Y);
                    continue;
                }
                bool rotated = false;
                Kostka found;
                try
                {
                    found = kostky.First(item =>
                    {
                        bool firstcond =
                        item.IsFitting(patrotmp, XX, YY, out rotated);
                        if (!firstcond)
                            return false;

                        Patro n_1 = (Patra.Count > 0) ? Patra[Patra.Count - 1] : null;

                        return !patrotmp.EdgeColorMatch(item, XX, YY, rotated, n_1);


                    });
                }
                catch { found = null; }
                if (found != null)
                {
                    found.Place(patrotmp, XX, YY, rotated);
                    found.rotated = rotated;
                    kostky = kostky.Where(item => item != found);
                }
                else { break; }
            }
            Patro.WriteToFile(file.Replace(".in", ".39"), Patra.ToArray(), "DB", X, Y);

        }
        static bool GetFreePositionP(Patro patro, out int X, out int Y)
        {
            for (int ix = 0; ix < patro.Kostky.GetLength(0); ix++)
            {
                for (int iy = 0; iy < patro.Kostky.GetLength(1); iy++)
                {
                    if (patro.Kostky[ix, iy] == null)
                    {
                        X = ix;
                        Y = iy;
                        return true;
                    }

                }
            }
            X = -1;
            Y = -1;
            return false;
        }


    }
    class Kostka
    {
        int rnd;
        public bool rotated = false;
        public char Barva;
        public int A, B;
        public Kostka(char Barva, int A, int B)
        {
            this.Barva = Barva;
            this.A = A;
            this.B = B;
            rnd = Stavitel.Program.rnd.Next(100);
        }
        public void Place(Patro p, int X, int Y, bool Rotated)
        {
            if (!Rotated)
            {
                for (int ix = X; ix < X + A; ix++)
                {
                    for (int iy = Y; iy < Y + B; iy++)
                    {
                        p.Kostky[ix, iy] = this;
                    }
                }


            }
            else
            {
                for (int ix = X; ix < X + B; ix++)
                {
                    for (int iy = Y; iy < Y + A; iy++)
                    {
                        p.Kostky[ix, iy] = this;
                    }
                }


            }
        }
        public bool IsFitting(Patro patro, int X, int Y, out bool Rotated)
        {
            if (IsFittingRN(patro, X, Y))
            {
                Rotated = false;
                return true;
            }
            else if (IsFittingR(patro, X, Y))
            {
                Rotated = true;
                return true;
            }
            Rotated = false;
            return false;

        }

        bool IsFittingRN(Patro patro, int X, int Y)
        {

            if (X + A > patro.Kostky.GetLength(0))
                return false;

            if (Y + B > patro.Kostky.GetLength(1))
                return false;

            bool tmp = false;
            for (int ix = X; ix < X + A && !tmp; ix++)
            {
                for (int iy = Y; iy < Y + B; iy++)
                {
                    if (patro.Kostky[ix, iy] != null)
                    { tmp = true; break; }
                }
            }
            return !tmp;

        }
        bool IsFittingR(Patro patro, int X, int Y)
        {

            if (X + B > patro.Kostky.GetLength(0))
                return false;

            if (Y + A > patro.Kostky.GetLength(1))
                return false;

            bool tmp = false;
            for (int ix = X; ix < X + B && !tmp; ix++)
            {
                for (int iy = Y; iy < Y + A; iy++)
                {
                    if (patro.Kostky[ix, iy] != null)
                    { tmp = true; break; }
                }
            }
            return !tmp;


        }
        public override string ToString()
        {
            return A.ToString() + " " + B.ToString() + " - " + rnd;
        }
    }
    class Patro
    {
        public int X, Y;
        public Kostka[,] Kostky;
        public Patro(int X, int Y)
        {
            this.X = X;
            this.Y = Y;
            Kostky = new Kostka[X, Y];
        }
        public bool EdgeColorMatch(Kostka k, int XX, int YY, bool rotated, Patro under)
        {
            Patro patrotmp = (Patro)this.MemberwiseClone();
            try
            {

                patrotmp.Kostky = (Kostka[,])Kostky.Clone();
                k.Place(patrotmp, XX, YY, rotated);
            }
            catch (Exception e) { e.ToString(); }

            if (under != null)
            {
                try
                {
                    if (X > 1)
                        for (int i = 1; i < X; i++)
                        {
                            if (patrotmp.Kostky[i, 0] != null && under.Kostky[i, 0] != null && patrotmp.Kostky[i, 0].Barva == under.Kostky[i, 0].Barva)
                                return true;
                            if (patrotmp.Kostky[i, Y - 1] != null && under.Kostky[i, Y - 1] != null && patrotmp.Kostky[i, Y - 1].Barva == under.Kostky[i, Y - 1].Barva)
                                return true;
                        }
                }
                catch (Exception e)
                { e.ToString(); }
                try
                {
                    if (Y > 1)
                        for (int i = 1; i < Y; i++)
                        {
                            if (patrotmp.Kostky[0, i] != null && under.Kostky[0, i] != null && patrotmp.Kostky[0, i].Barva == under.Kostky[0, i].Barva)
                                return true;
                            if (patrotmp.Kostky[X - 1, i] != null && under.Kostky[X - 1, i] != null && patrotmp.Kostky[X - 1, i].Barva == under.Kostky[X - 1, i].Barva)
                                return true;
                        }
                }
                catch (Exception e)
                { e.ToString(); }
            }



            try
            {
                if (X > 1)
                    for (int i = 1; i < X; i++)
                    {
                        if (patrotmp.Kostky[i, 0] != null && patrotmp.Kostky[i - 1, 0] != null && patrotmp.Kostky[i, 0].Barva == patrotmp.Kostky[i - 1, 0].Barva && patrotmp.Kostky[i - 1, 0] != patrotmp.Kostky[i, 0])
                            return true;
                        if (patrotmp.Kostky[i, Y - 1] != null && patrotmp.Kostky[i - 1, Y - 1] != null && patrotmp.Kostky[i, Y - 1].Barva == patrotmp.Kostky[i - 1, Y - 1].Barva && patrotmp.Kostky[i - 1, Y - 1] != patrotmp.Kostky[i, Y - 1])
                            return true;
                    }
            }
            catch (Exception e)
            { e.ToString(); }
            try
            {
                if (Y > 1)
                    for (int i = 1; i < Y; i++)
                    {
                        if (patrotmp.Kostky[0, i] != null && patrotmp.Kostky[0, i - 1] != null && patrotmp.Kostky[0, i].Barva == patrotmp.Kostky[0, i - 1].Barva && patrotmp.Kostky[0, i] != patrotmp.Kostky[0, i - 1])
                            return true;
                        if (patrotmp.Kostky[X - 1, i] != null && patrotmp.Kostky[X - 1, i - 1] != null && patrotmp.Kostky[X - 1, i].Barva == patrotmp.Kostky[X - 1, i - 1].Barva && patrotmp.Kostky[X - 1, i] != patrotmp.Kostky[X - 1, i - 1])
                            return true;
                    }
            }
            catch (Exception e)
            { e.ToString(); }
            return false;

        }

        public string[] Write()
        {
            List<Kostka> tmp = new List<Kostka>();
            List<string> Lines = new List<string>();
            for (int ix = 0; ix < X; ix++)
            {
                for (int iy = 0; iy < Y; iy++)
                {
                    Kostka k = Kostky[ix, iy];
                    if (!tmp.Contains(k))
                    {

                        tmp.Add(k);
                        Lines.Add(string.Format(k.rotated ? "{0} {1} {2} {4}x{3}" : "{0} {1} {2} {3}x{4}", ix + 1, iy + 1, k.Barva.ToString().ToUpper(), k.A, k.B));
                    }
                }
            }
            return Lines.ToArray();

        }
        static public void WriteToFile(string Path, Patro[] patra, string Type, int X, int Y)
        {
            StreamWriter sw = new StreamWriter(Path);
            sw.WriteLine(string.Format("{0} {1} {2}", X, Y, Type));
            for (int i = 0; i < patra.Length; i++)
            {


                foreach (var iitem in patra[i].Write())
                {
                    sw.WriteLine((i + 1).ToString() + " " + iitem);
                }
            }
            sw.Close();
        }
    }

}
